package com.tofly.xrtygis.custom.mapper;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.xrtygis.entity.Costbgfixed;
import com.tofly.xrtygis.entity.Costrlfixed;
import com.tofly.xrtygis.entity.Costrlwater;
import org.apache.ibatis.annotations.Select;
import org.springframework.data.repository.query.Param;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @author 20126
 */
public interface FixedMapper {
    /**
     * 查询当天制水指标详情
     * @param date 时间
     * @param mark 标记
     * @return list
     */
    Costrlwater selectWaterInfo(@Param("date") String date, @Param("mark") String mark);

    /**
     * 查询预算单变成本
     * @param month 月份
     * @return Costbgfixed
     */
    Costbgfixed viewFixedPlan(@Param("month") String month);

    /**
     * 查询财务填报单变
     * @param month 月份
     * @return Costrlfixed
     */
    Costrlfixed viewFinance(@Param("month") String month);

    /**
     * 查询本月单变累计值
     * @return map
     */
    Map<String, Object> viewSumFixed(@Param("start") String start, @Param("end") String end);

    /**
     * 查询当月每天制水单变
     * @return list
     */
    List<Map<String, Object>> viewFixed(@Param("start") String start, @Param("end") String end);

    /**
     * 查询当天制水单变
     * @param date 日期
     * @param mark 标记
     * @return Costrlfixed
     */
    Costrlfixed viewDayFixed(@Param("date") String date, @Param("mark") String mark);


    Page<Map> getPriceHistory(Page page, @Param("year") String year, @Param("start") String start, @Param("end") String end);

    @Select("select id\n" +
            "from TF_YWPN_COSTRLWATER_W\n" +
            "where MARK = #{mark}\n" +
            "  and to_char(UP_DATE, 'yyyy-mm') = to_char(#{upDate}, 'yyyy-mm')")
    Integer getWaterInfoId(String mark, Date upDate);

    Long existFinanceIsAllowed(@Param("date") Date date,@Param("start") String start,@Param("end") String end);


    List<Map> getFillInTheMessage(String month);
}
